#
# spec file for package Mesa (Version 6.4.2)
#
# Copyright (c) 2006 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild
# usedforbuild    aaa_base acl attr audit-libs autoconf automake bash bind-libs bind-utils binutils bison bzip2 coreutils cpio cpp cracklib cvs cyrus-sasl db diffutils e2fsprogs expat file filesystem fillup findutils flex fontconfig fontconfig-devel gawk gcc gcc-c++ gdbm gdbm-devel gettext gettext-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv klogd less libacl libattr libcom_err libdrm libdrm-devel libgcc libnscd libstdc++ libstdc++-devel libtool libxcrypt libzio m4 make man mktemp module-init-tools ncurses ncurses-devel net-tools netcfg openldap2-client openmotif-devel openmotif-libs openssl pam pam-modules patch perl permissions pkgconfig popt procinfo procps psmisc pwdutils rcs readline rpm sed strace sysvinit tar tcpd texinfo timezone unzip util-linux vim xorg-x11-devel xorg-x11-libs zlib zlib-devel

Name:           Mesa
BuildRequires:  gcc-c++ libdrm-devel openmotif-devel pkgconfig
URL:            http://www.mesa3d.org
%define USE_EXTERNAL_MESA 1
License:        X11/MIT
Group:          System/Libraries
Provides:       xorg-x11-Mesa XFree86-Mesa
Obsoletes:      xorg-x11-Mesa XFree86-Mesa
Autoreqprov:    on
Version:        6.4.2
Release:        19.12
Summary:        Mesa is a 3-D graphics library with an API which is very similar to that of OpenGL.*
Source:         Mesa-%{version}.tar.bz2
Source1:        missing-headers.tar.bz2
Source2:        glidelibs-i386.tar.gz
Source3:        README.updates
Source4:        manual-pages.tar.bz2
Patch:          Mesa-%{version}.diff
Patch1:         Mesa-glx-x11-render-texture-2.diff
Patch2:         missing-headers.diff
Patch3:         GLw-motif.diff
Patch4:         osmesa.diff
Patch5:         static.diff
Patch6:         Mesa_945GM.patch
Patch7:         glxext-sgi-hyperpipe.patch
Patch8:         mesa-6.4.2-scissor-fix-1.patch
Patch9:         mesa-6.4.2-dri-copy-sub-buffer-1.patch
Patch10:        licensefix.patch
Patch11:        googleearth.diff
Patch12:        Mesa-intel-texture-save-fix.diff
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
Mesa is a 3-D graphics library with an API which is very similar to
that of OpenGL.* To the extent that Mesa utilizes the OpenGL command
syntax or state machine, it is being used with authorization from
Silicon Graphics, Inc.(SGI). However, the author does not possess an
OpenGL license from SGI, and makes no claim that Mesa is in any way a
compatible replacement for OpenGL or associated with SGI. Those who
want a licensed implementation of OpenGL should contact a licensed
vendor.

Please do not refer to the library as MesaGL (for legal reasons). It's
just Mesa or The Mesa 3-D graphics library.

* OpenGL is a trademark of Silicon Graphics Incorporated.



Authors:
--------
    Brian Paul

%debug_package
%package devel
Requires:       Mesa = %version xorg-x11-devel
Summary:        Libraries, includes and more to develop Mesa applications
Group:          System/Libraries
Provides:       xorg-x11-Mesa-devel XFree86-Mesa-devel
Obsoletes:      xorg-x11-Mesa-devel XFree86-Mesa-devel

%description devel
Mesa is a 3-D graphics library with an API which is very similar to
that of OpenGL.* To the extent that Mesa utilizes the OpenGL command
syntax or state machine, it is being used with authorization from
Silicon Graphics, Inc.(SGI). However, the author does not possess an
OpenGL license from SGI, and makes no claim that Mesa is in any way a
compatible replacement for OpenGL or associated with SGI. Those who
want a licensed implementation of OpenGL should contact a licensed
vendor.

Please do not refer to the library as MesaGL (for legal reasons). It's
just Mesa or The Mesa 3-D graphics library.

* OpenGL is a trademark of Silicon Graphics Incorporated.



Authors:
--------
    Brian Paul

%package devel-static
Requires:       Mesa-devel = %version
Summary:        Static GL library - Usually not required at all
Group:          System/Libraries
Provides:       xorg-x11-Mesa-devel-static
Obsoletes:      xorg-x11-Mesa-devel-static

%description devel-static
Static GL library. It is not recommended at all to link against the
static GL library. Only included for legacy reasons.



Authors:
--------
    Brian Paul

%prep
%if !%{USE_EXTERNAL_MESA}
%setup -n %name -a1
%else
%setup -n %name -b4
%endif
# cleanup
find . -name CVS | xargs rm -rf
# no need to build GLUT and (GLUT-)Demos
rm -rf src/glut progs/{demos,redbook,samples,xdemos}
# we use freeglut
rm -f include/GL/{glut.h,uglglutshapes.h,glutf90.h}
%patch
%patch1
%if !%{USE_EXTERNAL_MESA}
%patch2
%endif
%patch3
cp configs/linux-osmesa16 configs/linux-osmesa
%patch4
cp configs/linux-osmesa configs/linux-osmesa-64
echo "LIB_DIR = \$(TOP)/lib64" >> configs/linux-osmesa-64
echo "EXTRA_LIB_PATH = -L/usr/X11R6/lib64" >> configs/linux-osmesa-64
%patch5
%patch6 -p1
%patch7 -p1
%patch8
%patch9
pushd src/glu/sgi/libnurbs/internals
%patch10
popd
%patch11
%patch12

%build
for dir in ../xc/doc/man/{GL,GLU}; do
pushd $dir
  xmkmf -a
  make
popd
done
%ifarch %ix86 ppc x86_64
%ifarch %ix86
make linux-dri-x86 OPT_FLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing -DDEFAULT_DRIVER_DIR='\"'/usr/X11R6/%{_lib}/modules/dri/updates:/usr/X11R6/%{_lib}/modules/dri'\"'"
make linux-x86-static OPT_FLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing"
%endif
%ifarch ppc
make linux-dri-ppc OPT_FLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing -DDEFAULT_DRIVER_DIR='\"'/usr/X11R6/%{_lib}/modules/dri/updates:/usr/X11R6/%{_lib}/modules/dri'\"'"
make linux-ppc-static OPT_FLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing"
%endif
%ifarch x86_64
make linux-dri-x86-64 OPT_FLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing -DDEFAULT_DRIVER_DIR='\"'/usr/X11R6/%{_lib}/modules/dri/updates:/usr/X11R6/%{_lib}/modules/dri'\"'"
make linux-x86-64-static OPT_FLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing"
%endif
%else
%ifnarch s390 s390x
make linux-dri OPT_FLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing -DDEFAULT_DRIVER_DIR='\"'/usr/X11R6/%{_lib}/modules/dri/updates:/usr/X11R6/%{_lib}/modules/dri'\"'"
%else
make linux OPT_FLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing"
%endif
make linux-static OPT_FLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing"
%endif

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr
for dir in ../xc/doc/man/{GL,GLU}; do
pushd $dir
  make install.man DESTDIR=$RPM_BUILD_ROOT MANPATH=%{_mandir} LIBMANSUFFIX=3gl
popd
done
make install DESTDIR=$RPM_BUILD_ROOT/usr
if [ "%{_lib}" != "lib" ]; then
  mv $RPM_BUILD_ROOT/usr/lib $RPM_BUILD_ROOT/usr/%{_lib}
fi
ln -snf libGL.a $RPM_BUILD_ROOT/usr/%{_lib}/libMesaGL.a
rm -f $RPM_BUILD_ROOT/usr/%{_lib}/libOSMesa.a
%ifnarch s390 s390x
mkdir -p  $RPM_BUILD_ROOT/usr/X11R6/%{_lib}/modules/dri
%ifarch ppc64
install -m 755 lib/*_dri.so $RPM_BUILD_ROOT/usr/X11R6/%{_lib}/modules/dri
%else
install -m 755 %{_lib}/*_dri.so $RPM_BUILD_ROOT/usr/X11R6/%{_lib}/modules/dri
%endif
%endif
# build and install OffScreen Mesa library
install -m 644 src/glw/GLw*.h $RPM_BUILD_ROOT/usr/include/GL
make realclean
%ifarch x86_64
make linux-osmesa-64 OPT_FLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing"
cp -a %{_lib}/libOSMesa.so* $RPM_BUILD_ROOT/usr/%{_lib}
%else
make linux-osmesa OPT_FLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing"
cp -a lib/libOSMesa.so* $RPM_BUILD_ROOT/usr/%{_lib}
%endif
#%ifarch %ix86
#tar xvzCf $RPM_BUILD_ROOT/usr/%{_lib} %SOURCE2
#%endif
# create dummy nvidia libGLcore.so.1 for applications, which are still
# linked against libGL.so.1 of older nvidia driver releases
> libGLcore.c
gcc -Wall -ansi -pedantic -c libGLcore.c -fPIC
ld -shared -soname libGLcore.so.1 -o $RPM_BUILD_ROOT/usr/%{_lib}/libGLcore.so.1.0 libGLcore.o
/sbin/ldconfig -n $RPM_BUILD_ROOT/usr/%_lib
# duplicate libGL to make workarounds like LD_PRELOAD possible if
# nvidia driver is installed and its libGl does not work
mkdir -p $RPM_BUILD_ROOT/usr/%{_lib}/GL
cp -a $RPM_BUILD_ROOT/usr/%{_lib}/libGL.so.* $RPM_BUILD_ROOT/usr/%{_lib}/GL
%ifnarch s390 s390x
# DRI driver update mechanism
mkdir -p $RPM_BUILD_ROOT/usr/X11R6/%{_lib}/modules/dri/updates
install -m 644 $RPM_SOURCE_DIR/README.updates \
  $RPM_BUILD_ROOT/usr/X11R6/%{_lib}/modules/dri/updates
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc docs/*
/usr/include/GL/
%dir /usr/%{_lib}/GL/
/usr/%{_lib}/libGL.so
/usr/%{_lib}/lib*.so.*
/usr/%{_lib}/GL/lib*.so.*
#%ifarch %ix86
#%{_libdir}/libglide3-v3.so
#%{_libdir}/libglide3-v5.so
#%endif
%ifnarch s390 s390x
%dir /usr/X11R6/%{_lib}/modules
/usr/X11R6/%{_lib}/modules/dri/
%endif

%files devel
%defattr(-,root,root)
/usr/include/GLES/
/usr/%{_lib}/libGLU.so
/usr/%{_lib}/libGLw.so
/usr/%{_lib}/libOSMesa.so
%{_mandir}/man3/*

%files devel-static
%defattr(-,root,root)
/usr/%{_lib}/libGL.a
/usr/%{_lib}/libMesaGL.a

%changelog -n Mesa
* Tue Sep 05 2006 - sndirsch@suse.de
- Mesa-intel-texture-save-fix.diff:
  * fixes STR issues with Xgl (Bug #182342)
* Fri Aug 04 2006 - sndirsch@suse.de
- googleearth.diff:
  * Call _mesa_resize_framebuffer() within intelWindowMoved().
  Fixes googleearth glitches. (Bug #188588)
* Mon Jun 19 2006 - sndirsch@suse.de
- added missing manual pages (Bug #185707)
* Fri May 19 2006 - sndirsch@suse.de
- fixed libGLcore.so.1 (e.g. soname); required to create a
  non-conflicting package for the NVIDIA driver (Bug #175683)
- no longer remove NVIDIA driver in %%pre
* Sat Apr 22 2006 - sndirsch@suse.de
- licensefix.patch:
  * fixed incompatible GPL license (Bug #133238, Mesa Bug #6490)
* Thu Apr 13 2006 - sndirsch@suse.de
- added /usr/X11R6/%%{_lib}/modules/dri/updates/README.updates to
  document DRI driver update mechanism
* Wed Apr 12 2006 - sndirsch@suse.de
- enhanced search path for DRI driver updates (FATE #300553)
* Mon Apr 03 2006 - sndirsch@suse.de
- mesa-6.4.2-dri-copy-sub-buffer-1.patch:
  * needed for open source drivers to work with Xgl (David Reveman)
* Wed Mar 15 2006 - mhopf@suse.de
- Fix for bug #157051, issue 1:
  On intel the graphics is only displayed correctly after a scissor region
  other than full screen is specified.
* Mon Feb 06 2006 - sndirsch@suse.de
- update to Mesa 6.4.2 (obsoletes tnl_init.diff)
  * New items:
- added OSMesaColorClamp() function/feature
- added wglGetExtensionStringARB() function
  * Bug fixes:
- fixed some problems when building on Windows
- GLw header files weren't installed by installmesa script (bug 5396)
- GL/glfbdev.h file was missing from tarballs
- fixed TNL initialization bug which could lead to crash (bug 5791)
* Mon Feb 06 2006 - sndirsch@suse.de
- tnl_init.diff (Mesa Bug #5791):
  * fixes TNL initialization bug which could lead to crash
  (CVS changelog: use calloc instead of malloc so try_codegen
  field is initialized to zero)
* Mon Jan 30 2006 - sndirsch@suse.de
- glxext-sgi-hyperpipe.patch:
  * GLX_SGIX_hyperpipe_group -> GLX_SGIX_hyperpipe (Bug #146646)
* Wed Jan 25 2006 - mls@suse.de
- converted neededforbuild to BuildRequires
* Fri Jan 20 2006 - sndirsch@suse.de
- Mesa_945GM.patch:
  * 945GM support by Charles Johnson (FATE #151391)
* Wed Dec 28 2005 - sndirsch@suse.de
- moved header files and libGL.so from Mesa-devel to Mesa to make
  uninstallation of nvidia driver in %%pre of Mesa-devel obsolete
* Wed Nov 30 2005 - sndirsch@suse.de
- update to Mesa 6.4.1
* Fri Nov 18 2005 - sndirsch@suse.de
- updated to Mesa 6.4 branch (2005-11-18)
- added static libGL (new Mesa-devel-static package)
- removed glut headers from installation (we use freeglut!)
* Tue Nov 15 2005 - sndirsch@suse.de
- updated to Mesa 6.4 branch (2005-11-12)
* Wed Nov 09 2005 - sndirsch@suse.de
- fixed libOSMesa build
* Tue Nov 08 2005 - sndirsch@suse.de
- added build of libOSMesa, e.g. required by tulip package
* Tue Nov 08 2005 - sndirsch@suse.de
- added include files for SGI's OpenGL Xt/Motif widgets, e.g.
  required by z88 package
  * GLwMDrawA.h
  * GLwDrawAP.h
  * GLwMDrawAP.h
  * GLwDrawA.h
- enabled Motif support in libGLw, also required by z88 package
* Mon Nov 07 2005 - sndirsch@suse.de
- use glx headers from xorg-x11-devel package
* Fri Oct 28 2005 - sndirsch@suse.de
- Mesa-glx-x11-render-texture-2.diff/missing-headers.diff:
  * new MESA_render_texture extension for Xgl (dreveman/mhopf)
* Tue Oct 25 2005 - sndirsch@suse.de
- fixed DRI driver path for 64bit platforms
* Tue Oct 25 2005 - sndirsch@suse.de
- update to Mesa 6.4
* Mon Oct 24 2005 - sndirsch@suse.de
- build DRI compatible libGL
* Fri Oct 21 2005 - sndirsch@suse.de
- added dummy nvidia libGLcore.so.1 for applications, which are
  still linked against libGL.so.1 of older nvidia driver releases
- duplicate libGL (located in /usr/lib/GL) to make workarounds
  like LD_PRELOAD possible if nvidia driver is installed and its
  libGl does not work
* Wed Oct 19 2005 - sndirsch@suse.de
- no longer install libglide (disables 3Dfx DRI support)
* Sun Oct 02 2005 - sndirsch@suse.de
- created package
